/*
 * BufferedREader.java
 *
 * Created on January 3, 2006, 11:22 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package util;

import java.io.IOException;
import java.io.Reader;


public class BufferedReader {
    private Reader in;
    private static int DEFAULT_LINE_LENGTH = 80;
    
    /** Creates a new instance of BufferedREader */
    public BufferedReader(Reader in) {
        this.in = in;
    }
    
    public String readLine() throws IOException {
        char c;
        StringBuffer buffer = new StringBuffer(DEFAULT_LINE_LENGTH);
        
        do {
            c = (char) in.read();
            if (c == '\r') {
                //Do nothing with it
            } else if (c == '\n') {
                return buffer.toString();
            } else if (c != 0) {
                buffer.append(c);
            }
        } while (c >= 0); //not EOF
        
        return null; //EOF
    }
    
    /**
     * Close the stream.
     *
     * @exception  IOException  If an I/O error occurs
     */
    public void close() throws IOException {
        if (in == null)
            return;
        in.close();
        in = null;
    }
}
