/*
 * Location.java
 *
 * Created on November 25, 2005, 10:22 PM
 */

package javax.microedition.location;

import javax.microedition.location.QualifiedCoordinates;

public class Location {
    public static final int MTA_ASSISTED =          0x00040000;
    public static final int MTA_UNASSISTED =        0x00080000;
    public static final int MTE_ANGLEOFARRIVAL =    0x00000020;
    public static final int MTE_CELLID =            0x00000008;
    public static final int MTE_SATELLITE =         0x00000001;
    public static final int MTE_SHORTRANGE =        0x00000010;
    public static final int MTE_TIMEDIFFERENCE =    0x00000002;
    public static final int MTE_TIMEOFARRIVAL =     0x00000004;
    public static final int MTY_NETWORKBASED =      0x00020000;
    public static final int MTY_TERMINALBASED =     0x00010000;
    
    public static final String mimeNMEA = "application/X-jsr179-location-nmea";
    public static final String mimeLif = "application/X-jsr179-location-lif";
    public static final String mimeText = "text/plain";
    
    /** Creates a new instance of Location */
    public Location() {
    }
    
//    /** Creates a new instance of Location */
//    public Location(javax.microedition.location.Location location) {
//        this.addressInfo = location.getAddressInfo();
//        this.course = location.getCourse();
//        setExtraInfo(location.getExtraInfo(mimeNMEA), mimeNMEA);
//        setExtraInfo(location.getExtraInfo(mimeLif), mimeLif);
//        setExtraInfo(location.getExtraInfo(mimeText), mimeText);
//        this.locationMethod = location.getLocationMethod();
//        this.qualifiedCoordinates = location.getQualifiedCoordinates();
//        this.speed = location.getSpeed();
//        this.timestamp = location.getTimestamp();
//        this.valid = location.isValid();
//    }    

    /**
     * Holds value of property addressInfo.
     */
    private AddressInfo addressInfo;

    /**
     * Getter for property addressInfo.
     * @return Value of property addressInfo.
     */
    public AddressInfo getAddressInfo() {

        return this.addressInfo;
    }

    /**
     * Setter for property addressInfo.
     * @param addressInfo New value of property addressInfo.
     */
    void setAddressInfo(AddressInfo addressInfo) {
        this.addressInfo = addressInfo;
    }

    /**
     * Holds value of property course.
     */
    private float course = Float.NaN;

    /**
     * Getter for property course.
     * @return Value of property course.
     */
    public float getCourse() {
        return this.course;
    }

    /**
     * Setter for property course.
     * @param course New value of property course.
     */
    void setCourse(float course) {
        this.course = course;
    }

    /**
     * Holds value of property extraInfo.
     */
    private String[] extraInfo = new String[3];

    /**
     * Getter for property extraInfo.
     * @return Value of property extraInfo.
     */
    public String getExtraInfo(String mimeType) {
        if (mimeType.indexOf(mimeNMEA) == 0) {
            return extraInfo[0];
        }
        if (mimeType.indexOf(mimeLif) == 0) {
            return extraInfo[1];
        }
        if (mimeType.indexOf(mimeText) == 0) {
            return extraInfo[2];
        }
        return null;
    }

    /**
     * Setter for property extraInfo.
     * @param extraInfo New value of property extraInfo.
     */
    void setExtraInfo(String extraInfo, String mimeType) {
        if (mimeType.indexOf(mimeNMEA) == 0) {
            this.extraInfo[0] = extraInfo;
        }
        if (mimeType.indexOf(mimeLif) == 0) {
            this.extraInfo[1] = extraInfo;
        }
        if (mimeType.indexOf(mimeText) == 0) {
            this.extraInfo[2] = extraInfo;
        }        
    }

    /**
     * Holds value of property locationMethod.
     */
    private int locationMethod;

    /**
     * Getter for property locationMethod.
     * @return Value of property locationMethod.
     */
    public int getLocationMethod() {
        return this.locationMethod;
    }

    /**
     * Setter for property locationMethod.
     * @param locationMethod New value of property locationMethod.
     */
    void setLocationMethod(int locationMethod) {
        this.locationMethod = locationMethod;
    }

    /**
     * Holds value of property qualifiedCoordinates.
     */
    private QualifiedCoordinates qualifiedCoordinates;

    /**
     * Getter for property qualifiedCoordinates.
     * @return Value of property qualifiedCoordinates.
     */
    public QualifiedCoordinates getQualifiedCoordinates() {
        return this.qualifiedCoordinates;
    }

    /**
     * Setter for property qualifiedCoordinates.
     * @param qualifiedCoordinates New value of property qualifiedCoordinates.
     */
    void setQualifiedCoordinates(QualifiedCoordinates qualifiedCoordinates) {
        this.qualifiedCoordinates = qualifiedCoordinates;
    }

    /**
     * Holds value of property speed.
     */
    private float speed = Float.NaN;

    /**
     * Getter for property speed.
     * @return Value of property speed.
     */
    public float getSpeed() {
        return this.speed;
    }

    /**
     * Setter for property speed.
     * @param speed New value of property speed.
     */
    void setSpeed(float speed) {
        if (speed < 0) {
            throw new IllegalArgumentException("Speed must be >= 0.");
        }
        this.speed = speed;
    }

    /**
     * Holds value of property timestamp.
     */
    private long timestamp;

    /**
     * Getter for property timestamp.
     * @return Value of property timestamp.
     */
    public long getTimestamp() {
        return this.timestamp;
    }

    /**
     * Setter for property timestamp.
     * @param timestamp New value of property timestamp.
     */
    void setTimestamp(long timestamp) {
        this.timestamp = timestamp;
    }

    /**
     * Holds value of property valid.
     */
    private boolean valid;

    /**
     * Getter for property valid.
     * @return Value of property valid.
     */
    public boolean isValid() {
        return this.valid;
    }

    /**
     * Setter for property valid.
     * @param valid New value of property valid.
     */
    void setValid(boolean valid) {
        this.valid = valid;
    }
    
}
