/*
 * GpsPostPreferences.java
 *
 * Created on December 1, 2005, 6:06 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package traxx;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import javax.microedition.rms.RecordStore;
import javax.microedition.rms.RecordStoreException;

public class GpsPostPreferences {
    public static final int POSTING_MODE_HTTP = 0;
    public static final int POSTING_MODE_UDP = 1;
    
    public static final int SENSOR_NONE = 0;
    public static final int SENSOR_SOR_R_20 = 1;
    public static final int SENSOR_MULTI_RAE_PLUS = 2;
    public static final int SENSOR_DELIMITED_SERIAL = 3;
    
    private static final int RECORD_ID = 1;
    private static final String STORE_NAME = "GPSPostPrefs";
    
    /**
     * Holds value of property message.
     */
    String[] messages = { "Enter message",
            "Good",
            "Bad",
            "Mobile", "Clear", "5", "6", "7", "8", "9",
    };
    
    /**
     * Creates a new instance of GpsPostPreferences
     */
    public GpsPostPreferences() {
        RecordStore rs = null;
        try {
            rs = RecordStore.openRecordStore( STORE_NAME, false );
            retrieve();
        } catch( RecordStoreException e ){
            save(); //Save the defaults
        } finally {
            try {
                if (rs != null) {
                    rs.closeRecordStore();
                }
            } catch( RecordStoreException e ){
                // Ignore this exception
            }
        }
    }
    
    /**
     * Holds value of property userName.
     */
    private String userName = "NewUser";
    
    /**
     * Getter for property userName.
     * @return Value of property userName.
     */
    public String getUserName() {
        return this.userName;
    }
    
    /**
     * Setter for property userName.
     * @param userName New value of property userName.
     */
    public void setUserName(String userName) {
        this.userName = userName;
    }
    
    /**
     * Holds value of property password.
     */
    private String password ="";
    
    /**
     * Getter for property password.
     * @return Value of property password.
     */
    public String getPassword() {
        return this.password;
    }
    
    /**
     * Setter for property password.
     * @param password New value of property password.
     */
    public void setPassword(String password) {
        this.password = password;
    }
    
    /**
     * Indexed getter for property message.
     * @param index Index of the property.
     * @return Value of the property at <CODE>index</CODE>.
     */
    public String getMessage(int index) {
        if (0 <= index && index < messages.length) {
            return this.messages[index];
        } else {
            return null;
        }
        
    }
    
    /**
     * Indexed setter for property message.
     * @param index Index of the property.
     * @param message New value of the property at <CODE>index</CODE>.
     */
    public void setMessage(int index, String message) {
        this.messages[index] = message;
    }
    
    /**
     * Holds value of property httpUrl.
     */
    private String httpUrl = "http://tim1.us/cgi-bin/traxx/traxxsql_v1.pl";
    
    /**
     * Getter for property serverUrl.
     * @return Value of property serverUrl.
     */
    public String getHttpUrl() {
        return this.httpUrl;
    }
    
    /**
     * Setter for property serverUrl.
     * @param serverUrl New value of property serverUrl.
     */
    public void setHttpUrl(String httpUrl) {
        this.httpUrl = httpUrl;
    }

    /**
     * Holds value of property udpUrl.
     */
    private String udpUrl = "datagram://www.tim1.us:5555";
//    private String udpUrl = "datagram://localhost:5555";

    /**
     * Getter for property udpUrl.
     * @return Value of property udpUrl.
     */
    public String getUdpUrl() {
        return this.udpUrl;
    }

    /**
     * Setter for property udpUrl.
     * @param udpUrl New value of property udpUrl.
     */
    public void setUdpUrl(String udpUrl) {
        this.udpUrl = udpUrl;
    }
    
    /**
     * Holds value of property locationIntervalPostingEnabled.
     */
    private boolean locationIntervalPostingEnabled = true;

    /**
     * Getter for property intervalPostEnabled.
     * @return Value of property intervalPostEnabled.
     */
    public boolean isLocationIntervalPostingEnabled() {

        return this.locationIntervalPostingEnabled;
    }

    /**
     * Setter for property intervalPostEnabled.
     * @param intervalPostEnabled New value of property intervalPostEnabled.
     */
    public void setLocationIntervalPostingEnabled(boolean locationIntervalPostingEnabled) {

        this.locationIntervalPostingEnabled = locationIntervalPostingEnabled;
    }    
    
    /**
     * Holds value of property locationPostInterval.
     */
    private int locationPostInterval = 5;

    /**
     * Getter for property postInterval.
     * @return Value of property postInterval.
     */
    public int getLocationPostInterval() {

        return this.locationPostInterval;
    }

    /**
     * Setter for property postInterval.
     * @param postInterval New value of property postInterval.
     */
    public void setLocationPostInterval(int locationPostInterval) {

        this.locationPostInterval = locationPostInterval;
    }    
    
    public void fromByteArray( byte[] data ) throws IOException {
        ByteArrayInputStream bin = new ByteArrayInputStream(data);
        DataInputStream din = new DataInputStream( bin );
        
        fromDataStream( din );
        din.close();
    }
    
    public byte[] toByteArray() throws IOException {
        ByteArrayOutputStream bout = new ByteArrayOutputStream();
        DataOutputStream dout = new DataOutputStream( bout );
        
        toDataStream( dout );
        dout.close();
        
        return bout.toByteArray();
    }
    
    public void fromDataStream( DataInputStream din )
    throws IOException {
        //version
        //match?
        userName = din.readUTF();
        password = din.readUTF();
        postingMode = din.readInt();
        httpUrl = din.readUTF();
        udpUrl = din.readUTF();
        locationIntervalPostingEnabled = din.readBoolean();
        locationPostInterval = din.readInt();
        sensor = din.readInt();
        sensorIntervalPostingEnabled = din.readBoolean();
        sensorPostInterval = din.readInt();
        serialDelimiter = din.readUTF();
        serialPushEnabled = din.readBoolean();
        for (int i=0; i < 10; i++) {
            messages[i] = din.readUTF();
            if (messages[i].equalsIgnoreCase("")) {
                messages[i] = null;
            }
        }
    }
    
    public void toDataStream( DataOutputStream dout )
    throws IOException {
        //version
        dout.writeUTF(userName == null ? "" : userName );
        dout.writeUTF(password == null ? "" : password );
        dout.writeInt(postingMode);
        dout.writeUTF(httpUrl == null ? "" : httpUrl );
        dout.writeUTF(udpUrl == null ? "" : udpUrl );
        dout.writeBoolean(locationIntervalPostingEnabled);
        dout.writeInt(locationPostInterval);
        dout.writeInt(sensor);
        dout.writeBoolean(sensorIntervalPostingEnabled);
        dout.writeInt(sensorPostInterval);
        dout.writeUTF(serialDelimiter);
        dout.writeBoolean(serialPushEnabled);
        for (int i=0; i < 10; i++) {
            //dout.writeUTF(messages[i] == null ? "" : messages[i] );
            dout.writeUTF(messages[i] == null ? "" : messages[i]);
        }
    }
    
    public void save() {
        RecordStore rs = null;
        
        try {
            //Open the record store, creating one if necessary
            rs = RecordStore.openRecordStore(STORE_NAME, true);
        } catch( RecordStoreException e ){
            System.err.println(e);
        }
        
        try {
            byte[] data = toByteArray();
            if (rs.getNextRecordID() == 1) {
                rs.addRecord(data, 0, data.length);
            } else {
                rs.setRecord(RECORD_ID, data, 0, data.length );
            }
            
        } catch( RecordStoreException e ){
            System.err.println(e);
        } catch( IOException e ){
            System.err.println(e);
        } finally {
            try {
                rs.closeRecordStore();
            } catch( RecordStoreException e ){
                // Ignore this exception
            }
        }
    }
    
    public void retrieve() {
        RecordStore rs = null;
        
        try {
            //Open the record store
            rs = RecordStore.openRecordStore(STORE_NAME, false);
            
            if (rs != null) {
                byte[] data = rs.getRecord(RECORD_ID);
                fromByteArray(data);
            }
            
        } catch( RecordStoreException e ){
            System.err.println(e);
        } catch( IOException e ){
            System.err.println(e);
        } finally {
            try {
                rs.closeRecordStore();
            } catch( RecordStoreException e ){
                // Ignore this exception
            }
        }
    }

    /**
     * Holds value of property sensorIntervalPostingEnabled.
     */
    private boolean sensorIntervalPostingEnabled = false;

    /**
     * Getter for property sensorIntervalPostingEnabled.
     * @return Value of property sensorIntervalPostingEnabled.
     */
    public boolean isSensorIntervalPostingEnabled() {

        return this.sensorIntervalPostingEnabled;
    }

    /**
     * Setter for property sensorIntervalPostingEnabled.
     * @param sensorIntervalPostingEnabled New value of property sensorIntervalPostingEnabled.
     */
    public void setSensorIntervalPostingEnabled(boolean sensorIntervalPostingEnabled) {

        this.sensorIntervalPostingEnabled = sensorIntervalPostingEnabled;
    }

    /**
     * Holds value of property sensorPostInterval.
     */
    private int sensorPostInterval = 10;

    /**
     * Getter for property sensorPostInterval.
     * @return Value of property sensorPostInterval.
     */
    public int getSensorPostInterval() {

        return this.sensorPostInterval;
    }

    /**
     * Setter for property sensorPostInterval.
     * @param sensorPostInterval New value of property sensorPostInterval.
     */
    public void setSensorPostInterval(int sensorPostInterval) {

        this.sensorPostInterval = sensorPostInterval;
    }

    /**
     * Holds value of property sensor.
     */
    private int sensor = 0;

    /**
     * Getter for property sensor.
     * @return Value of property sensor.
     */
    public int getSensor() {
        return this.sensor;
    }

    /**
     * Setter for property sensor.
     * @param sensor New value of property sensor.
     */
    public void setSensor(int sensor) {
        this.sensor = sensor;
    }
    
    /**
     * Holds value of property postingMode.
     */
    //private int postingMode;
    private int postingMode = POSTING_MODE_UDP;

    /**
     * Getter for property postingMode.
     * @return Value of property postingMode.
     */
    public int getPostingMode() {
        return this.postingMode;
    }

    /**
     * Setter for property postingMode.
     * @param postingMode New value of property postingMode.
     */
    public void setPostingMode(int postingMode) {
        this.postingMode = postingMode;
    }
    
    public String toString() {
        return new String(
                "Server HTTP URL: " + httpUrl + "\n"
                + "Server UDP URL: " + udpUrl + "\n"
                + "User name: " + userName + "\n"
                + "Password: " + password + "\n"
                + "Posting mode: " + postingMode + "\n"
                + "Periodic location: " + locationIntervalPostingEnabled + "\n" 
                + "Location interval: " + locationPostInterval + "\n"
                + "Sensor: " + sensor + "\n"
                + "Periodic sensor: " + sensorIntervalPostingEnabled + "\n"
                + "Sensor interval: " + sensorPostInterval + "\n"
                + "Serial delimeter: " + serialDelimiter + "\n"
                + "Serial push: " + serialPushEnabled);
    }

    /**
     * Holds value of property serialDelimiter.
     */
    private String serialDelimiter = "13";

    /**
     * Getter for property serialDelimiter.
     * @return Value of property serialDelimiter.
     */
    public String getSerialDelimiter() {
        return this.serialDelimiter;
    }

    /**
     * Setter for property serialDelimiter.
     * @param serialDelimiter New value of property serialDelimiter.
     */
    public void setSerialDelimiter(String serialDelimiter) {
        this.serialDelimiter = serialDelimiter;
    }

    /**
     * Holds value of property serialPushEnabled.
     */
    private boolean serialPushEnabled;

    /**
     * Getter for property serialPushEnabled.
     * @return Value of property serialPushEnabled.
     */
    public boolean isSerialPushEnabled() {
        return this.serialPushEnabled;
    }

    /**
     * Setter for property serialPushEnabled.
     * @param serialPushEnabled New value of property serialPushEnabled.
     */
    public void setSerialPushEnabled(boolean serialPushEnabled) {
        this.serialPushEnabled = serialPushEnabled;
    }
}
